<template>
    <div class="hc-layout-box">
        <HcCard :scrollbar="false" actionSize="lg">
            <template #header>
                <HcTooltip keys="gauge-bezier-add">
                    <el-button type="primary" hc-btn @click="addLineEleModal" :disabled="searchForm.partId.length<1">
                        <HcIcon name="add-box"/>
                        <span>添加线元</span>
                    </el-button>
                </HcTooltip>
                <HcTooltip keys="gauge-bezier-to">
                    <el-button hc-btn @click="showToModalClick">
                        <HcIcon name="repeat"/>
                        <span>转换坐标</span>
                    </el-button>
                </HcTooltip>
                <HcTooltip keys="gauge-bezier-pile">
                    <el-button hc-btn @click="pileModalClick">
                        <HcIcon name="settings-6"/>
                        <span>逐桩坐标</span>
                    </el-button>
                </HcTooltip>
                <HcTooltip keys="gauge-bezier-import">
                    <el-button hc-btn @click="importModalClick">
                        <HcIcon name="upload-cloud"/>
                        <span>导入</span>
                    </el-button>
                </HcTooltip>
                <HcTooltip keys="gauge-bezier-export">
                    <el-button hc-btn :loading="downloadLoading" @click="exportModalClick">
                        <HcIcon name="download"/>
                        <span>导出</span>
                    </el-button>
                </HcTooltip>
            </template>
            <template #extra>
                <div class="w-60">
                    <el-select v-model="searchForm.partId" block clearable size="large" placeholder="片段查询" @change="searchClick">
                        <el-option v-for="item in partData" :label="item.name" :value="item.id"/>
                    </el-select>
                </div>
                <HcTooltip keys="gauge-bezier-add-part">
                    <div class="hc-extra-icon-btn" @click="AddPartClick">
                        <HcIcon name="add-circle"/>
                    </div>
                </HcTooltip>
                <HcTooltip keys="gauge-bezier-admin-part">
                    <div class="hc-extra-icon-btn" @click="AdminPartClick">
                        <HcIcon name="list-settings"/>
                    </div>
                </HcTooltip>
            </template>

            <HcTable :column="tableColumn" :datas="tableData" :loading="tableLoading">
                <template #name="{row}">
                    {{row['valueStr']}}~{{row['valueEndStr']}}
                </template>
                <template #type="{row}">
                    {{getTypeName(row?.type)}}
                </template>
                <!-- <template #angle="{row}">
                    {{row['du']}}°{{row['fen']}}′{{row['miao']}}″
                </template> -->
                <template #action="{row}">
                    <HcTooltip keys="gauge-station-edit">
                        <el-button type="primary" size="small" text @click="handleTableEdit(row)">编辑</el-button>
                    </HcTooltip>
                    <HcTooltip keys="gauge-station-del">
                        <el-button type="danger" size="small" text @click="handleTableDelete(row)">删除</el-button>
                    </HcTooltip>
                </template>
            </HcTable>
            <template #action>
                <HcPages :pages="searchForm" @change="pageChange"/>
            </template>
        </HcCard>
        <!--管理片段弹框-->
        <el-dialog v-model="showAdminPartModal" title="管理片段" width="47rem" class="hc-modal-border">
            <div class="admin-part-data-table">
                <el-scrollbar>
                    <div class="hc-table-ref-box">
                        <el-table hc :data="AdminPartTableData" stripe>
                            <el-table-column prop="name" label="片段名称">
                                <template #default="scope">
                                    <el-input v-model="scope.row.name" placeholder="片段名称" v-if="scope.row.isEdit"/>
                                    <div v-else>{{scope.row.name}}</div>
                                </template>
                            </el-table-column>
                            <el-table-column prop="prefix" label="桩号前缀">
                                <template #default="scope">
                                    <el-input v-model="scope.row.prefix" placeholder="桩号前缀" v-if="scope.row.isEdit"/>
                                    <div v-else>{{scope.row.prefix}}</div>
                                </template>
                            </el-table-column>
                            <el-table-column label="操作" align="center" width="130">
                                <template #default="scope">
                                    <el-button type="primary" size="small" text @click="handleAdminPartSave(scope.row)" v-if="scope.row.isEdit">保存</el-button>
                                    <HcTooltip keys="gauge-station-edit" v-else>
                                        <el-button type="primary" size="small" text @click="handleAdminPartEdit(scope.row)">编辑</el-button>
                                    </HcTooltip>
                                    <HcTooltip keys="gauge-station-del">
                                        <el-button type="danger" size="small" text @click="handleAdminPartDelete(scope.row,scope.$index)">删除</el-button>
                                    </HcTooltip>
                                </template>
                            </el-table-column>
                        </el-table>
                    </div>
                </el-scrollbar>
            </div>
            <template #footer>
                <div class="dialog-footer">
                    <el-button size="large" @click="showAdminPartModal = false">取消</el-button>
                    <el-button type="primary" hc-btn @click="AddAdminPart">新增</el-button>
                </div>
            </template>
        </el-dialog>
        <!--新增片段弹框-->
        <el-dialog v-model="showAddPartModal" title="新增片段" width="38rem" draggable class="hc-modal-border">
            <el-form ref="partFormRef" :model="partForm" :rules="partRules" label-width="auto" size="large">
                <el-form-item label="名称" prop="name">
                    <el-input v-model="partForm.name" placeholder="请输入名称"/>
                </el-form-item>
                <el-form-item label="桩号前缀" prop="prefix">
                    <el-input v-model="partForm.prefix" placeholder="只允许输入大写的英文字母"/>
                </el-form-item>
            </el-form>
            <template #footer>
                <div class="dialog-footer">
                    <el-button size="large" @click="showAddPartModal = false">取消</el-button>
                    <el-button type="primary" hc-btn :loading="savePartLoading" @click="savePartInfo">保存</el-button>
                </div>
            </template>
        </el-dialog>
        <!--添加/编辑线元弹框-->
        <el-dialog v-model="showLineEleModal" :title="(formLineEleValue.id === -1 || !formLineEleValue.id)?'添加线元':'编辑线元'" draggable width="40rem" class="hc-modal-border">
            <el-form :model="formLineEleValue" label-width="auto" size="large">
                <el-form-item label="类型">
                    <el-radio-group v-model="formLineEleValue.type">
                        <el-radio v-for="item in lineElementType" :label="item.value">{{ item.label }}</el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="开始里程">
                    <el-input v-model="formLineEleValue.value" placeholder="请输入开始里程"/>
                </el-form-item>
                <el-form-item label="X">
                    <el-input v-model="formLineEleValue.x" placeholder="请输入X"/>
                </el-form-item>
                <el-form-item label="Y">
                    <el-input v-model="formLineEleValue.y" placeholder="请输入Y"/>
                </el-form-item>
                <el-form-item label="半径" v-if="formLineEleValue.type !== 0">
                    <el-input v-model="formLineEleValue.r" placeholder="请输入半径"/>
                </el-form-item>
                <el-form-item label="结束半径" v-if="formLineEleValue.type === 3">
                    <el-input v-model="formLineEleValue.r2" placeholder="请输入半径"/>
                </el-form-item>
                <el-form-item label="转向" v-if="formLineEleValue.type !== 0">
                    <el-radio-group v-model="formLineEleValue.swing">
                        <el-radio label="左转">左转</el-radio>
                        <el-radio label="右转">右转</el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="线长度">
                    <el-input v-model="formLineEleValue.l" placeholder="请输入线长度"/>
                </el-form-item>
                <div class="flex">
                    <el-form-item class="flex-1" label="方位角">
                        <el-input v-model="formLineEleValue.du" placeholder="输入度">
                            <template #suffix>度</template>
                        </el-input>
                    </el-form-item>
                    <el-form-item class="flex-1 ml-4" no-label>
                        <el-input v-model="formLineEleValue.fen" placeholder="输入分">
                            <template #suffix>分</template>
                        </el-input>
                    </el-form-item>
                    <el-form-item class="flex-1 ml-4" no-label>
                        <el-input v-model="formLineEleValue.miao" placeholder="输入秒">
                            <template #suffix>秒</template>
                        </el-input>
                    </el-form-item>
                </div>
                <el-form-item label="断链前里程" v-if="formLineEleValue.type !== 3">
                    <el-input v-model="formLineEleValue.dlq" placeholder="请输入断链前里程"/>
                </el-form-item>
                <el-form-item label="断链后里程" v-if="formLineEleValue.type !== 3">
                    <el-input v-model="formLineEleValue.dlh" placeholder="请输入断链后里程"/>
                </el-form-item>
                <el-form-item label="顺序">
                    <el-input v-model="formLineEleValue.orderNum" placeholder="请输入顺序"/>
                </el-form-item>
            </el-form>
            <template #footer>
                <div class="dialog-footer">
                    <el-button size="large" @click="showLineEleModal = false">取消</el-button>
                    <el-button size="large" @click="refreshable" v-if="formLineEleValue.id === -1 || !formLineEleValue.id">刷新</el-button>
                    <el-button type="primary" hc-btn :loading="saveLoading" @click="saveLineEleClick">保存</el-button>
                </div>
            </template>
        </el-dialog>
        <!--里程转换坐标-->
        <el-dialog v-model="showToModal" title="里程转换坐标" width="38rem" draggable class="hc-modal-border">
            <el-form :model="formToValue" label-width="auto" size="large">
                <el-form-item label="里程">
                    <el-input v-model="formToValue.value" placeholder="请输入名称"/>
                </el-form-item>
                <el-form-item label="偏移">
                    <el-input v-model="formToValue.b" placeholder="请输入偏移"/>
                </el-form-item>
                <el-form-item label="夹角">
                    <el-input v-model="formToValue.jj" placeholder="请输入夹角"/>
                </el-form-item>
                <el-form-item label="X">
                    <div class="form-item-div">{{formToValue.x}}</div>
                </el-form-item>
                <el-form-item label="Y">
                    <div class="form-item-div">{{formToValue.y}}</div>
                </el-form-item>
            </el-form>
            <template #footer>
                <div class="dialog-footer">
                    <el-button size="large" @click="showToModal = false">取消</el-button>
                    <el-button type="primary" hc-btn @click="queryPsChange">转换</el-button>
                </div>
            </template>
        </el-dialog>
        <!--逐桩坐标弹框-->
        <el-dialog v-model="showPileModal" title="逐桩坐标" width="62rem" draggable class="hc-modal-border">
            <el-form :model="formPileValue" label-width="auto" size="large" inline label-position="top">
                <el-form-item label="开始桩号">
                    <el-input v-model="formPileValue.x" placeholder="开始桩号"/>
                </el-form-item>
                <el-form-item label="结束桩号">
                    <el-input v-model="formPileValue.y" placeholder="结束桩号"/>
                </el-form-item>
                <el-form-item label="桩距">
                    <el-input v-model="formPileValue.value" placeholder="桩距"/>
                </el-form-item>
                <el-form-item label="偏距">
                    <el-input v-model="formPileValue.b" placeholder="偏距"/>
                </el-form-item>
                <el-form-item label=" ">
                    <el-button type="primary" attr-type="button" :loading="generateLoading" @click="generateClick">生成</el-button>
                </el-form-item>
            </el-form>
            <div class="admin-part-data-table">
                <el-scrollbar>
                    <div class="hc-table-ref-box">
                        <el-table hc :data="pileTable" stripe>
                            <el-table-column prop="num" label="序号" width="80">
                                <template #default="scope">
                                    {{scope.$index + 1}}
                                </template>
                            </el-table-column>
                            <el-table-column prop="valueStr" label="里程"/>
                            <el-table-column prop="b" label="偏距"/>
                            <el-table-column prop="xxStr" label="X"/>
                            <el-table-column prop="yyStr" label="Y"/>
                        </el-table>
                    </div>
                </el-scrollbar>
            </div>
        </el-dialog>
        <!--导入弹框-->
        <el-dialog v-model="showImportModal" title="导入线元" width="32rem" class="hc-modal-border">
            <div class="text-center">
                <el-upload ref="uploadRef" :action="action" :headers="getTokenHeader()" :accept="accept" :data="addition" :limit="1" :auto-upload="false" v-model:file-list="fileList"
                           :on-exceed="handleUploadExceed" :on-progress="handleUploadProgress" :on-success="handleUploadFinish" :on-error="handleUploadError">
                    <template #trigger>
                        <el-button type="primary" :loading="importLoading">选择文件</el-button>
                    </template>
                </el-upload>
            </div>
            <template #footer>
                <div class="lr-dialog-footer">
                    <div class="left">
                        <el-button size="large" @click="tmportTmpClick">下载导入模板</el-button>
                    </div>
                    <div class="right">
                        <el-button size="large" @click="showImportModal = false">取消</el-button>
                        <el-button type="primary" hc-btn :disabled="fileList.length <= 0" :loading="importLoading" @click="handleImportClick">确认导入</el-button>
                    </div>
                </div>
            </template>
        </el-dialog>
    </div>
</template>

<script setup>
import {ref, onMounted} from "vue";
import {useAppStore} from "~src/store";
import bezierApi from '~api/gauge/bezier';
import {getTokenHeader} from '~src/api/request/header';
import {isType, downloadBlob, formValidate, deepClone} from "vue-utils-plus"
import {genFileId} from "element-plus";

//初始变量
const useAppState = useAppStore()
const projectId = ref(useAppState.getProjectId);
const contractId = ref(useAppState.getContractId);
const { isObjNull, getObjValue,  getArrValue } = isType()

//渲染完成
onMounted(() => {
    queryPartList()
})

//获取下拉列表
const partData = ref([])
const queryPartList = async () => {
    const { error, code, data } = await bezierApi.queryPartList({
        projectId: projectId.value,
        contractId: contractId.value
    })
    if (!error && code === 200) {
        let records = getArrValue(data)
        partData.value = records
        AdminPartTableData.value = deepClone(records);
        if (records.length > 0 && !searchForm.value.partId) {
            searchForm.value.partId = records[0].id;
            partNo.value= records[0].prefix
            getTableData()
        }
    } else {
        partData.value = []
        AdminPartTableData.value = [];
        searchForm.value.partId = null;
    }
}

//搜索表单
const searchForm = ref({partId: '', current: 1, size: 20, total: 0})
const partNo=ref('')
//重新搜索数据
const searchClick = (id) => {
    partData.value.forEach((ele)=>{
        if(ele.id===id){
           partNo.value=ele.prefix 
        }
    })
    searchForm.value.current = 1
    getTableData()
}

//分页被点击
const pageChange = ({current, size}) => {
    searchForm.value.current = current
    searchForm.value.size = size
    getTableData()
}

//获取数据
const tableColumn = ref([
    {key:'name', name: '里程'},
    {key:'orderNum', name: '排序'},
    {key:'l', name: '长度'},
    {key:'angleStr', name: '方位角'},
    {key:'type', name: '类型'},
    {key:'swing', name: '转向'},
    {key:'xxStr', name: 'X'},
    {key:'yyStr', name: 'Y'},
    {key:'r', name: '半径'},
    {key:'action', name: '操作', width: '130'}
])
const tableData = ref([])
const tableLoading = ref(false)
const getTableData = async () => {
    tableLoading.value = true
    const { error, code, data } = await bezierApi.queryListData(searchForm.value)
    tableLoading.value = false
    if (!error && code === 200) {
        tableData.value = getArrValue(data['records'])
        searchForm.value.total = data['total'] || 0
    } else {
        tableData.value = []
        searchForm.value.total = 0
    }
}

//编辑表格
const handleTableEdit = (row) => {
    const form = deepClone(row)
    formLineEleValue.value['id'] = form['id'];
    formLineEleValue.value['type'] = form['type'];
    formLineEleValue.value['projectId'] = projectId.value;
    formLineEleValue.value['contractId'] = contractId.value;
    formLineEleValue.value['partId'] = searchForm.value.partId;
    let mile = ['x', 'y', 'fen', 'miao', 'du', 'value', 'l',  'dlq', 'dlh', 'swing', 'r', 'r2', 'orderNum']
    mile.forEach((key) => {
        formLineEleValue.value[key] = form[key] + '';
    })
    saveLoading.value = false
    showLineEleModal.value = true
}
//删除表格
const handleTableDelete = (row) => {
    window?.$messageBox?.alert('是否删除当前数据？', '删除提醒', {
        showCancelButton: true,
        confirmButtonText: '确定删除',
        cancelButtonText: '取消',
        callback: (action) => {
            if (action === 'confirm') {
                saveDelMileage(row.id)
            }
        }
    })
}
//确认删除
const saveDelMileage = async (rid) => {
    const {error, code} = await bezierApi.saveDelMileage({id: rid}, false)
    //判断状态
    if (!error && code === 200) {
        window?.$message?.success('删除成功')
        getTableData()
    } else {
        window?.$message?.error('删除失败')
    }
}

//线元类型
const showLineEleModal = ref(false)
const formLineEleValue = ref({type: 0})
const lineElementType = ref([
    {value: 0, label: "直线段"},
    {value: 1, label: "圆曲线"},
    {value: 2, label: "入缓和曲线"},
    {value: 3, label: "出缓和曲线"},
    {value: 4, label: "不完整缓和曲线"},
])
//获取类型名称
const getTypeName = (val) => {
    if (val !== -1 || val >= 0) {
        return lineElementType.value[val].label || '';
    } else {
        return '-';
    }
}
//添加线元
const addLineEleModal = () => {
    saveLoading.value = false
    showLineEleModal.value = true
    getNextMileagexy()
}
//刷新
const refreshable = () => {
    getNextMileagexy({
        orderNum: formLineEleValue.value['orderNum']
    })
}
//保存
const saveLoading = ref(false)
const saveLineEleClick = async () => {
    let form = formLineEleValue.value
    form.partId = searchForm.value.partId;
    if (form.id === -1 || !form.id) {
        saveLoading.value = true
        const { error, code } = await bezierApi.saveAddMileage(form)
        saveLoading.value = false
        if (!error && code === 200) {
            window?.$message?.success('保存成功')
            showLineEleModal.value = false
            getTableData()
        }
    } else {
        saveLoading.value = true
        const { error, code } = await bezierApi.saveUpdateMileage(form)
        saveLoading.value = false
        if (!error && code === 200) {
            window?.$message?.success('保存成功')
            showLineEleModal.value = false
            getTableData()
        }
    }
}
//获取数据
const getNextMileagexy = async (obj = {}) => {
    const { error, code, data } = await bezierApi.getNextMileagexy({
        ...obj,
        projectId: projectId.value,
        contractId: contractId.value
    })
    if (!error && code === 200) {
        const res = getObjValue(data)
        if (!isObjNull(res)) {
            let mile = ['x', 'y', 'fen', 'miao', 'du', 'value', 'l',  'dlq', 'dlh', 'swing', 'r', 'r2', 'orderNum']
            mile.forEach((key) => {
                formLineEleValue.value[key] = res[key] + '';
            })
            formLineEleValue.value['type'] = res['type'];
            formLineEleValue.value['projectId'] = projectId.value;
            formLineEleValue.value['contractId'] = contractId.value;
            formLineEleValue.value['partId'] = searchForm.value.partId;
        } else {
            formLineEleValue.value = {type: 0}
            formLineEleValue.value['projectId'] = projectId.value;
            formLineEleValue.value['contractId'] = contractId.value;
            formLineEleValue.value['partId'] = searchForm.value.partId;
        }
    }
}

//转换坐标
const showToModal = ref(false)
const formToValue = ref({value: '', b: '0', jj: '90', x: '', y: ''})
const showToModalClick = () => {
    formToValue.value = {value: '', b: '0', jj: '90', x: '', y: ''}
    showToModal.value = true
}
//转换坐标
const queryPsChange = async () => {
    const {error, code, data} = await bezierApi.queryPsChange({
        ...formToValue.value,
        projectId: projectId.value,
        partId: searchForm.value.partId
    })
    //判断状态
    if (!error && code === 200) {
        const res = getObjValue(data)
        formToValue.value['x'] = res?.x + '';
        formToValue.value['y'] = res?.y + '';
        window?.$message?.success('转换成功')
    }
}

//逐桩坐标
const showPileModal = ref(false)
const formPileValue = ref({})
const pileModalClick = () => {
    formPileValue.value = {x: '0', y: '0', value: '0', b: '0'}
    pileTable.value = []
    generateLoading.value = false
    showPileModal.value = true
}
//确认生成
const generateLoading = ref(false)
const pileTable = ref([])
const generateClick = async () => {
    generateLoading.value = true
    const {error, code, data} = await bezierApi.getZzList({
        ...formPileValue.value,
        projectId: projectId.value,
        partId: searchForm.value.partId
    })
    //判断状态
    generateLoading.value = false
    if (!error && code === 200) {
        pileTable.value = getArrValue(data);
    } else {
        pileTable.value = [];
    }
}

//导入配置
const showImportModal = ref(false)
const importLoading = ref(false)

//上传配置
const uploadRef = ref(null)
const addition = ref({})
const fileList = ref([])
const action = '/api/blade-business/mileage/import';
const accept = 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel';

//导入
const importModalClick = () => {
    addition.value = {
        projectId: projectId.value,
        contractId: contractId.value,
        partId: searchForm.value.partId
    }
    importLoading.value = false
    showImportModal.value = true
}

//下载导入模板
const tmportTmpClick = () => {
    window.open('https://bladex-test-info.oss-cn-chengdu.aliyuncs.com//upload/20220614/a8bb45b57e409ff6bd5a5aad4bc7b22e.xlsx','_blank')
}
//上传一个文件时，重置
const handleUploadExceed = (files) => {
    uploadRef.value?.clearFiles()
    const file = files[0]
    file.uid = genFileId()
    uploadRef.value?.handleStart(file)
}

//确认导入
const handleImportClick = () => {
    uploadRef.value?.submit()
}
//上传中
const handleUploadProgress = () => {
    importLoading.value = true
}
//上传完成
const handleUploadFinish = (res) => {
    importLoading.value = false
    showImportModal.value = false
    if (res.code === 200) {
        window?.$message?.success(res.msg)
        uploadRef.value?.clearFiles()
        getTableData()
    } else {
        window?.$message?.error(res.msg)
    }
}
//上传失败
const handleUploadError = (res) => {
    importLoading.value = false
    window?.$message?.error(res.msg || '导入失败')
}

//导出
const exportModalClick = () => {
    window?.$messageBox?.alert('请确认当前查询条件，系统将以当前筛选条件导出数据', '导出数据', {
        showCancelButton: true,
        confirmButtonText: '确定导出',
        cancelButtonText: '取消',
        callback: (action) => {
            if (action === 'confirm') {
                getExportExcel()
            }
        }
    })
}
//确定导出
const downloadLoading = ref(false)
const getExportExcel = async () => {
    //批量下载
    downloadLoading.value = true
    const { error, disposition, res } = await bezierApi.getExportExcel({
        projectId: projectId.value,
        partId: searchForm.value.partId,
        partNo: partNo.value
    })
    //处理数据
    downloadLoading.value = false
    if (!error) {
        if (disposition) {
            downloadBlob(res,disposition)
        } else {
            window.$message?.error('数据异常')
        }
    }
}


//片段管理表单
const partFormRef = ref(null)
const partForm = ref({name: '', prefix: ''})
const partRules = {
    name: {
        required: true,
        trigger: "blur",
        message: "请输入名称"
    },
    prefix: {
        required: true,
        validator: (rule, value, callback) => {
            const reg = /^[A-Z]+$/
            if (value && !reg.test(value)) {
                callback(new Error('只允许输入大写的英文字母'))
            } else {
                callback()
            }
        },
        trigger: "blur",
    }
}

//管理片段
const showAdminPartModal = ref(false)
const AdminPartTableData = ref([])
const AdminPartClick = () => {
    AdminPartTableData.value = deepClone(partData.value);
    showAdminPartModal.value = true
}

//新增片段弹框
const showAddPartModal = ref(false)
const AddPartClick = () => {
    partForm.value = {name: '', prefix: ''}
    savePartLoading.value = false
    showAddPartModal.value = true
}
//新增保存
const savePartLoading = ref(false)
const savePartInfo = async () => {
    const validate = await formValidate(partFormRef.value)
    if (validate) {
        savePartLoading.value = true
        const { error, code } = await bezierApi.savePartAdd({
            ...partForm.value,
            projectId: projectId.value,
            contractId: contractId.value
        })
        savePartLoading.value = false
        if (!error && code === 200) {
            window?.$message?.success('新增成功')
            showAddPartModal.value = false
            queryPartList()
        }
    }
}

//新增
const AddAdminPart = () => {
    AdminPartTableData.value.push({
        id: '', name: '', prefix: '', isEdit: true
    })
}
//编辑
const handleAdminPartEdit = (row) => {
    row.isEdit = true
}

//保存
const handleAdminPartSave = async (row) => {
    //严格模式/^[A-Z]+((#\d+)?|\d+)$/
    const reg = /^[A-Z#-\d]+$/  
    if (!row.name) {
        window?.$message?.warning('请输入名称')
    } else if (!row.prefix&&row.name.indexOf('主线')<0) {
      //没有前缀，且片段名称中不包含‘主线’
        window?.$message?.warning('请输入桩号前缀')
    } else if (!reg.test(row.prefix)&&row.name.indexOf('主线')<0) {
        window?.$message?.warning('桩号前缀,只允许输入大写的英文字母')
    } else if (row.id) {
        const { error, code } = await bezierApi.savePartUpdate({
            ...row,
            projectId: projectId.value,
            contractId: contractId.value
        })
        if (!error && code === 200) {
            window?.$message?.success('保存成功')
            row.isEdit = false
            queryPartList()
        }
    } else if (!row.id) {
        const { error, code ,data} = await bezierApi.savePartAdd({
            ...row,
            projectId: projectId.value,
            contractId: contractId.value
        })
        if (!error && code === 200) {
            window?.$message?.success('保存成功')
            row.isEdit = false
            alert(222);
            row.id=data.id
            partData.value.push(data)
            //queryPartList()不要刷新
        }
    }
}

//删除
const handleAdminPartDelete = (row, index) => {
    if (!!row.id) {
        window?.$messageBox?.alert('关联平曲线一起删除', '是否删除当前数据？', {
        showCancelButton: true,
        confirmButtonText: '确定删除',
        cancelButtonText: '取消',
        callback: (action) => {
            if (action === 'confirm') {
                handleAdminPartDeleteSub(row, index)
             }
            }
        })
    } else {
        AdminPartTableData.value.splice(index, 1)
    }
}

const handleAdminPartDeleteSub = async (row, index) => {
        const { error, code  } = await bezierApi.delPartData({
            ids: row.id
        })
        if (!error && code === 200) {
            window?.$message?.success('删除成功')
            queryPartList()
        }
    
}


</script>

<style lang="scss" scoped>
@import '../../styles/gauge/bezier.scss';
</style>
